<template>
  <div class="step-frame">
    <div class="frame">
      <div class="upload-frame">
        <AppDragDrop @change="createBadge" />
        <AppFileInput @change="createBadge" />
      </div>
      <div class="filenames">
        <h3>Название</h3>
        <AppBadge v-for="(doc, id) of docs" :key="id" :text="doc.name">
          <AppButton
            :theme="buttonThemes.ico"
            :icon="buttonIcons.remove"
            @click="askForRemoveFile(id)"
          />
        </AppBadge>
      </div>
    </div>
  </div>
  <ModalDialog
    title="Удалить выбранный документ ?"
    text="Выбранные вами объекты удалятся без возможности восстановления."
    :show="showDialog"
  >
    <template #actions>
      <AppButton :theme="buttonThemes.light" @click="cancelRemove">
        Отмена
      </AppButton>
      <AppButton :theme="buttonThemes.prime" @click="deleteFile">
        Удалить
      </AppButton>
    </template>
  </ModalDialog>
</template>
<script>
import AppDragDrop from "@/components/UI/AppDragDrop.vue";
import AppFileInput from "@/components/UI/AppFileInput.vue";
import { mapState } from "vuex";
import AppBadge from "@/components/UI/AppBadge.vue";
import AppButton, {
  themes as buttonThemes,
  icons as buttonIcons,
} from "@/components/UI/AppButton.vue";
import ModalDialog from "@/components/ModalDialog.vue";
import store from "@/store";
import baseApi from "@/api/baseApi";

export default {
  name: "TaskStep2",
  components: { ModalDialog, AppButton, AppBadge, AppFileInput, AppDragDrop },
  data() {
    return {
      buttonIcons,
      buttonThemes,
      showDialog: false,
      idForRemove: null,
      docForRemove: null,
    };
  },
  computed: {
    isEditStatus: {
      get: () => store.state.isEditMode,
      set: (val) => store.commit("changeEditMode", val),
    },
    ...mapState({ docsForUpload: (state) => state.taskDetails.docsForUpload }),
    ...mapState({ docs: (state) => state.taskDetails.docs }),
  },
  methods: {
    createBadge(files) {
      this.$store.commit(
        "updateStep2ForUpload",
        this.docsForUpload.concat(Array.from(files).map((file) => file))
      );
      this.$store.commit(
        "updateStep2Docs",
        this.docs.concat(Array.from(files).map((file) => file))
      );
    },
    deleteFile() {
      if (this.docForRemove?.taskId === undefined) {
        // просто удаляем из списков
        const idForUploadRemove = this.docsForUpload.find(
          (item, name) => name === this.docForRemove.name
        );
        this.docs.splice(this.idForRemove, 1);
        this.docsForUpload.splice(idForUploadRemove, 1);
      } else {
        // удаляем на сервере
        baseApi
          .delete("/task/document/" + this.docForRemove.id, {}, {})
          .then((res) => {
            if (res.data === true) {
              this.docs.splice(this.idForRemove, 1);
            } else {
              console.error(res.data);
            }
          });
      }

      this.idForRemove = null;
      this.docForRemove = null;
      this.showDialog = false;
    },
    askForRemoveFile(idFind) {
      this.docForRemove = this.docs.find((item, id) => id === idFind);
      this.idForRemove = idFind;
      this.showDialog = true;
    },
    cancelRemove() {
      this.showDialog = false;
      this.idForRemove = null;
      this.docForRemove = null;
    },
  },
};
</script>
<style>
.upload-frame {
  width: 50%;
  margin-right: 25px;
}
.filenames {
  width: 50%;
  margin-left: 25px;
}
.frame {
  display: flex;
}
</style>
